/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include"ssd1306.h"

#define LOW      GPIO_PIN_RESET 
#define HIGH     GPIO_PIN_SET 
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
 
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
uint8_t swch=1;
uint32_t tmr=0;
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
void pir(void) {
	

uint32_t i=0; 
	
tmr=tmr*1000;
	
ssd1306_SetCursor(35, 36);
ssd1306_WriteString("     ", Font_11x18, White);
ssd1306_SetCursor(2, 0);
ssd1306_WriteString("  PIR  ",  Font_16x26, White);
ssd1306_UpdateScreen();	

while (HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_6)==LOW) {	
	
if((HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_9)==HIGH)||(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_12)==HIGH)){
	 
	
	 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_10, HIGH);
   HAL_Delay(500);
	 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_10,LOW);
   HAL_Delay(500);
	
	 	  HAL_GPIO_WritePin(GPIOB, GPIO_PIN_10,HIGH);
	
	   for(i=0; i<=tmr; i++){
			   if(HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_6)==HIGH) i=tmr;
			   HAL_Delay(1);		 
	  }	
}	
  if((HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_9)==LOW)&&(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_12)==LOW)){
	
	    HAL_GPIO_WritePin(GPIOB, GPIO_PIN_10,LOW);
		  HAL_Delay(100);	
   
	 } 
 } 
   HAL_GPIO_WritePin(GPIOB, GPIO_PIN_10,LOW);
   HAL_Delay(10);
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  /* USER CODE BEGIN 2 */
   ssd1306_Init();
   HAL_Delay(100);
	 ssd1306_SetCursor(35, 36);
	 ssd1306_WriteString("     ", Font_11x18, White);
	 ssd1306_SetCursor(2, 20);
	 ssd1306_WriteString("Init...",  Font_16x26, White);
	 ssd1306_UpdateScreen();	
   HAL_Delay(2000); 
	 ssd1306_SetCursor(35, 36);
	 ssd1306_WriteString("     ", Font_11x18, White);
	 ssd1306_SetCursor(2, 20);
	 ssd1306_WriteString("        ",  Font_16x26, White);
	 ssd1306_UpdateScreen();	
	 
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
		
		if(HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_7)==HIGH) pir();
		
		if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_0)==HIGH)swch--, HAL_Delay(150);
		if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_1)==HIGH)swch++, HAL_Delay(150); 
		
		 if(swch<1) swch=5;
		 if(swch>5) swch=1;


    	switch(swch){ 
          case 1:
					 tmr=29; //aprox 1 min
	          ssd1306_SetCursor(35, 36);
		        ssd1306_WriteString("     ", Font_11x18, White);
	         ssd1306_SetCursor(2, 0);
	         ssd1306_WriteString(" 1 min",  Font_16x26, White);
	         ssd1306_UpdateScreen();	
          break;
				  case 2:
						tmr=59;//aprox 2 min
	          ssd1306_SetCursor(35, 36);
		        ssd1306_WriteString("     ", Font_11x18, White);
	         ssd1306_SetCursor(2, 0);
	         ssd1306_WriteString(" 2 min",  Font_16x26, White);
	         ssd1306_UpdateScreen();	
          break;	
				   case 3:
						tmr=89; //aprox 3 min
	          ssd1306_SetCursor(35, 36);
		        ssd1306_WriteString("     ", Font_11x18, White);
	         ssd1306_SetCursor(2, 0);
	         ssd1306_WriteString(" 3 min",  Font_16x26, White);
	         ssd1306_UpdateScreen();	
          break;
				  case 4:
						tmr=119; //aprox 4 min
	          ssd1306_SetCursor(35, 36);
		        ssd1306_WriteString("     ", Font_11x18, White);
	          ssd1306_SetCursor(2, 0);
	          ssd1306_WriteString(" 4 min",  Font_16x26, White);
	          ssd1306_UpdateScreen();	
          break;
				case 5:
						tmr=149; //aprox 5 min
	          ssd1306_SetCursor(35, 36);
		        ssd1306_WriteString("     ", Font_11x18, White);
	          ssd1306_SetCursor(2, 0);
	          ssd1306_WriteString(" 5 min",  Font_16x26, White);
	          ssd1306_UpdateScreen();	
          break;			
					
	  }		

  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 12;
  RCC_OscInitStruct.PLL.PLLN = 96;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
